
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CurrenciesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const currencies = await db.currencies.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        symbol: data.symbol
        ||
        null
            ,
            
        minor_unit: data.minor_unit
        ||
        null
            ,
            
        is_base: data.is_base
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await currencies.setBusiness( data.business || null, {
            transaction,
        });
        

        

        

        return currencies;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const currenciesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                symbol: item.symbol
            ||
            null
            ,
            
                minor_unit: item.minor_unit
            ||
            null
            ,
            
                is_base: item.is_base
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const currencies = await db.currencies.bulkCreate(currenciesData, { transaction });

        // For each item created, replace relation files
        

        return currencies;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const currencies = await db.currencies.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.symbol !== undefined) updatePayload.symbol = data.symbol;
        
        
        if (data.minor_unit !== undefined) updatePayload.minor_unit = data.minor_unit;
        
        
        if (data.is_base !== undefined) updatePayload.is_base = data.is_base;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await currencies.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await currencies.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        

        
        

        

        return currencies;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const currencies = await db.currencies.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of currencies) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of currencies) {
                await record.destroy({transaction});
            }
        });


        return currencies;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const currencies = await db.currencies.findByPk(id, options);

        await currencies.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await currencies.destroy({
            transaction
        });

        return currencies;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const currencies = await db.currencies.findOne(
            { where },
            { transaction },
        );

        if (!currencies) {
            return currencies;
        }

        const output = currencies.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        output.currency_rates_from_currency = await currencies.getCurrency_rates_from_currency({
            transaction
        });
        
        output.currency_rates_to_currency = await currencies.getCurrency_rates_to_currency({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.contracts_currency = await currencies.getContracts_currency({
            transaction
        });
        
        
        output.cash_boxes_currency = await currencies.getCash_boxes_currency({
            transaction
        });
        
        
        
        output.bank_accounts_currency = await currencies.getBank_accounts_currency({
            transaction
        });
        
        
        output.letters_of_credit_currency = await currencies.getLetters_of_credit_currency({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        output.journal_lines_currency = await currencies.getJournal_lines_currency({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await currencies.getBusiness({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              trade_name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'currencies',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'currencies',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.symbol) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'currencies',
                        'symbol',
                        filter.symbol,
                    ),
                };
            }
            

            
            

            
            if (filter.minor_unitRange) {
                const [start, end] = filter.minor_unitRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    minor_unit: {
                    ...where.minor_unit,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    minor_unit: {
                    ...where.minor_unit,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_base) {
                where = {
                    ...where,
                is_base: filter.is_base,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.currencies.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'currencies',
                        'code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.currencies.findAll({
            attributes: [ 'id', 'code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.code,
        }));
    }

    
};

